#!/bin/bash
#
# programa de instalacin y personalizacin del paquete freevote
#
# <C> Juan Antonio Martnez Junio-2000

cd `dirname $0`
BASE=`pwd`

#compilamos documentacion
echo "Generando documentacion...."
( 
	cd $BASE/usr/doc
	# Convierte gifs en EPS
	for i in *.gif ; do
		tmpfile=$TMPDIR/gif2ps.$$
		echo procesando $i
		gif2ps -q -x $i > $tmpfile  
		ps2epsi $tmpfile `echo $i | sed -e 's/\.gif/.eps/g'`	
		rm -f $tmpfile
	done
	# Genera INSTALL.TXT
	sgml2txt --charset=latin install.sgml 
	mv install.txt $BASE/INSTALL.TXT
	# Genera HTML's a partir del SGML
	sgml2html --charset=latin install.sgml 
	sgml2html --charset=latin documentacion.sgml 
	sgml2html --charset=latin article.sgml 
	# Genera Docs en formato PostScript
	sgml2latex --charset=latin --papersize=a4 --language=es --output=ps install.sgml
	sgml2latex --charset=latin --papersize=a4 --language=es --output=ps documentacion.sgml
	sgml2latex --charset=latin --papersize=a4 --language=es --output=ps article.sgml
echo "Hecho."
)

# compilamos el programa para encriptar
(
	echo -n "Compilando encriptador... "
	gcc -O2 $BASE/usr/lib/freevote/lib/crypt.c -o $BASE/usr/bin/freevote_crypt -lcrypt
	echo "Hecho."
)

# generamos fichero tgz
(
	echo -n "Generando fichero de backup..."
	tar zcf $BASE/usr/lib/freevote/html/freevote.tgz --exclude='*gz' .
	echo "Hecho."
)

cp $BASE/COPYING $BASE/usr/lib/freevote/html
exit 0
