#!/bin/bash
#
# Programa para registrar una lista de usuarios en el sistema Free-Vote
#
# Uso: register_list fichero_lista
#
# Formato de listas
# Apellidos:Nombre:Direccion:telefono:email

# <C> Juan Antonio Martnez Junio-2000
 
[ -x /etc/freevote.conf ] || (
        echo "Fichero de configuracion no existe o no ejecutable. $0 Abortado"
        exit 1
)
 
. /etc/freevote.conf

sqlquery () {
        psql -d $DBNAME -F : -h $DBHOST -p $DBPORT -t -A -q -U $DBUSER -c "$*"
}                                                                               

if [ "$1" = "" -o ! -f $1 ]; then
	echo "Debe indicar fichero con lista de usuarios a registrar"
	exit 1
fi

linea=0
# leemos el fichero de registro
cat $1 |\
 while IFS=':' read apellidos nombre direccion telefono email ; do
	linea=`expr $linea + 1`
	[ ! -z $apellidos -a ! -z $nombre -a ! -z direccion -a ! -z telefono -a ! -z email ] || (
	 echo "Error en lnea $linea . Omitiendo datos..."
	 continue
	)
	# evaluamos contrasea
	sqlkey=`${FREEVOTE_INST}/bin/freevote_crypt $email`

	# insertamos en database
 	com="INSERT INTO usuarios \
                (groupid,passwd,nombre,apellidos,direccion,telefono,email) \
        VALUES ( 1,'$sqlkey','$nombre','$apellidos','$direccion','$telefono','$email');"
        sqlquery $com 2> /dev/null
        if [ $? -ne 0 ]; then
            echo "Error en INSERT: Posiblemente el usuario est ya registrado"
            continue
        fi

	# obtenemos el userid
        com="SELECT userid FROM usuarios WHERE email='$email';"
        userid=`sqlquery $com` 

	# enviamos correo notificando inscripcin
	# echo -e "enviando correo a $apellidos,$nombre\n Direccion $direccion\n Telefono $telefono\n Email $email\n Userid $userid\n"
	[ -f ${FREEVOTE_INST}/lib/freevote/lib/templates/done_register_user ] || (
		echo "No encuentro fichero template de correo"
		continue
	)
	/lib/cpp -D__DBTITLE__="$DBTITLE" \
		-D__WEBPAGE__="$WEBURL" \
		-D__APELLIDOS__="$apellidos" \
		-D__NOMBRE__="$nombre" \
		-D__DIRECCION__="$direccion" \
		-D__TELEFONO__="$telefono" \
		-D__EMAIL__="$email" \
		-D__USERID__="$userid" \
		-D__ADMIN_EMAIL__="$ADMIN_EMAIL" \
		${FREEVOTE_INST}/lib/freevote/lib/templates/done_register_user |\
	mail $email -s "Notificacin de registro en $DBTITLE"
done
