<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>
<title>Free-Vote: Emision de voto</title>
</head>
<body>
<? require('tools.php3'); ?>
<? check_https(); ?>
<?
	$conn = db_Open("Error Abriendo base de datos");
	
	// buscamos en la database la consulta
	$vote=lookup_vote($conn,$evote_voteid,"consultas");
	$censo=lookup_list($conn,$vote->id_lista);
	
	// comprobamos los derechos de acceso del usuario
	certify_user($conn, $evote_email, $evote_userid, $evote_passwd, "Error: Usuario no registrado, o datos invlidos");
	esta_censado( $conn, $evote_userid, $censo->id_lista, "Consulta restringida: El usuario no pertenece a la lista de votantes" );

	// buscamos datos de usuario y de encuesta
	$user=lookup_user($conn,$evote_userid,"usuarios");

	// pequeo chequeo para garantizar que no nos mandan un formulario
	// trucado o con datos invlidos: verificamos que la opcin
	// seleccionada coincida con alguna de las opciones posibles
	if ( $enviar=="Enviar voto" ) {
		$com=sprintf("SELECT * FROM respuestas WHERE id_consulta=%s AND short_answer='%s';",$evote_voteid,$vote_sel);
    		$res2 = sqlquery( $conn,$com,"Error en consulta de opciones" );
		if ( db_numrows($res2) == 0 ) {
			$msg=sprintf("Uid: %d\tVoteid: %d\tInvalid Option\t Value: %s\n",$user->userid,$vote->voteid,$vote_sel);
			register_event("EVENT_VOTE",LOG_WARNING,$msg);
			show_error("Error en contenido del voto: posible intento de hacking");
		}
	}
	// buscamos datos sobre el censo de votantes	
	// Vemos la operacion a realizar
	printf("<h1><i>%s</i></h1>\n",$vote->titulo);
	if ( $enviar=="Enviar voto" ) {
		printf("<h3>Free-Vote: Emisin de Voto</h3><hr>\n");
		// puede votar ?
		$res=puede_votar($conn,$evote_userid,$evote_voteid);
		if ( $res==0 ) {
			$msg=sprintf("Uid: %d\tVoteid: %d\tCannot Vote\n",$user->userid,$vote->voteid);
			register_event("EVENT_VOTE",LOG_INFO,$msg);
			show_error("Error: fuera de plazo o usuario no inscrito en censo");
		}
		// esta inscrito ?
		$res=esta_inscrito($conn,$evote_userid,$evote_voteid);
		if ( $res==0 ) {
			show_error("Error: debe inscribirse primero");
		}
		// ha votado ya ?
		$res=ha_votado($conn,$evote_userid,$evote_voteid);
		if ( $res==1 ) {
			$msg=sprintf("Uid: %d\tVoteid: %d\tAlready voted\n",$user->userid,$vote->voteid);
			register_event("EVENT_VOTE",LOG_NOTICE,$msg);
			show_error("Error: El usuario ha emitido ya su voto");
		}
		// si todo ok comprobamos tarjeta censal
		$res=verify_votecard($conn,$evote_userid,$evote_voteid,$evote_votekey);
		if ( $res== 0 ) {
			$msg=sprintf("Uid: %d\tVoteid: %d\tInvalid Key\n",$user->userid,$vote->voteid);
			register_event("EVENT_VOTE",LOG_ERR,$msg);
			show_error("Error en datos de tarjeta de voto");
		}
		// a votaaaaaarrrrrr !!!!
		do_vote($conn,$user,$vote,$vote_sel );
		printf("<p>Su voto ha sido emitido.<br>En breve recibira un mensaje de correo electrnico de confirmacin</p>\n");
		// se le envia correo notificando el voto
		emitted_vote($user,$vote);
		// se envia notificacion a los interventores
		notifica_voto($conn,$user,$vote,$vote_sel);
		// manda evento al syslog
		// Si no secreto, se aade valor del voto
		if ($vote->is_secret=="t") {
			$msg=sprintf("Uid: %d\tVoteid: %d\tSend vote\n",$user->userid,$vote->voteid);
		} else {
			$msg=sprintf("Uid: %d\tVoteid: %d\tSend vote\t Value: %s\n",$user->userid,$vote->voteid,$vote_sel);
		}
		register_event("EVENT_VOTE",LOG_NOTICE,$msg);
	}
	if ( $enviar=="Solicitar inscripcin" ) {
		printf("<h3>Free-Vote: Solicitud de Tarjeta de Voto</h3><hr>\n");
		// puede inscribirse ?
		// ha votado ya ?
		$res=ha_votado($conn,$evote_userid,$evote_voteid);
		if ( $res==1 ) {
			$msg=sprintf("Uid: %d\tVoteid: %d\tAlready voted\n",$user->userid,$vote->voteid);
			register_event("EVENT_VOTE",LOG_NOTICE,$msg);
			show_error("Error: El usuario ha emitido ya su voto");
		}
		$res=puede_inscribirse($conn,$evote_userid,$evote_voteid);
		if ( $res==0 ) {
			$msg=sprintf("Uid: %d\tVoteid: %d\tCannot Vote\n",$user->userid,$vote->voteid);
			register_event("EVENT_VOTE",LOG_INFO,$msg);
			show_error("Error: fuera de plazo o usuario no inscrito en censo");
		}
		$key=do_inscripcion($conn,$user,$vote);
		// envia la tarjeta censal
		printf("<p>Solicitud de voto registrada<br>\n");
		printf("Su clave de voto es <b>%s</b><br>\n",$key);
		printf("En breve plazo recibir confirmacin por correo electrnico</p>\n");
		// se le notifica por correo electrnico
		ask_for_key($user,$vote,$key,$vote->titulo);
		// se envia notificacion a los interventores
		notifica_tarjeta($conn,$user,$vote);
		// se guarda evento en el syslog. 
		$msg=sprintf("Uid: %d\tVoteid: %d\t Ask for voting key\n",$user->userid,$vote->voteid);
		register_event("EVENT_VOTE",LOG_NOTICE,$msg);
	}
?>
<hr>
</ol>
</body>
</html>

