<?

$GLOBALS[debug]=0;
define_syslog_variables();

require('config.php3');

// --------------------------- FUNCIONES GENERALES -----------------------

// en el futuro esto servir para independizar el software de la base de 
// datos, utilizando funciones genricas, y usando un "db.php3" que sea
// lo nico dependiente de la db

require ("${DB_PROGRAM}.php3");

// cuando se produce un error cierra el texto html
function cierra_html() {
	printf ("</body>\n </html>\n");
}

// presenta mensaje de error y aborta ejecucion
function show_error ($msg) {
	printf("<p>\n%s\n</p>\n",$msg);
	cierra_html();
	exit;
}

//-------------------- CHEQUEOS ---------------------------------

// funcion cerrojo que bloquea el acceso a una pgina marcada
// como segura si se accede por http en lugar de por https
// solo tiene efecto cuando Free-Vote se instala con USE_HTTPS=1
function check_https() {
	if ( $GLOBALS["USE_HTTPS"]==0 ) return 0;
	// TODO: revisar
	// presuponemos que se usa el puerto standard para https.
	// realmente, habra que mirarlo de otra forma....
	$port=getenv("SERVER_PORT");
	if ($port!=443) show_error("Debe usar protocolo https en la conexion");
	return 1;
}

// devuelve un string indicando el url y ajustando el protocolo
function get_url($str) {
	if ( $GLOBALS["USE_HTTPS"]==0 ) return $GLOBALS["WEBURL"]; 
	if ( $str=="WEBURL" ) return $GLOBALS["WEBURL"];
	return str_replace("http://","https://",$GLOBALS["WEBURL"]);
}

//-------------------- REGISTRO DE SUCESOS -----------------------

function register_event($type,$level,$message) {
	// formato del evento: (campos separados por tabuladores )
	// fecha "Y-m-d H:i:s"
	// tipo EVENT_ { AUTH ADMIN ACCESS VOTE REGISTRY DEBUG }
	// nivel LOG_ { DEBUG INFO NOTICE WARNING ERR CRIT ALERT EMERG }
	// mensaje
	if (! isset($GLOBALS[$type]) ) { // tipo de error no definido
		register_event("EVENT_DEBUG",LOG_ERR,"Undefined event type");
		return 0;
	}	
	if ( ($level>7) || ($level<0) ) { // nivel de error incorrecto
		register_event("EVENT_DEBUG",LOG_ERR,"Undefined event level");
		return 0;
	}	
	if ( $level > $GLOBALS[$type] ) return 0; // no log need to be done
	$levelmsg[7]="DEBUG"; $levelmsg[6]="INFO"; 
	$levelmsg[5]="NOTICE"; $levelmsg[4]="WARNING"; 
	$levelmsg[3]="ERR"; $levelmsg[2]="CRIT";
	$levelmsg[1]="ALERT"; $levelmsg[0]="EMERG"; 
	// componemos mensaje de log
	$str=sprintf("%s\t%s\t%s\n",$type,$levelmsg[$level],$message);
	// $logfile=sprintf("%s/%s.log",$GLOBALS["LOGDIR"],$GLOBALS["DBNAME"]);
	// error_log($str,3,$logfile);
	openlog("freevote",0,$GLOBALS["SYSLOG"]);
	syslog($level,$str);
	closelog();
	return 0;
}

//-------------------- CONSULTA DE DATOS -------------------------

// rutina general de peticion de datos a la database
function sqlquery ( $conn, $comm, $errormsg) {
	if ( $GLOBALS[debug]==1) printf("<p>%s</p>\n",$comm);
        $res = db_query( $conn,$comm );
        if ( !$res ) show_error($errormsg);
        return $res;
}                                                                               

// obtiene el userid de un usuario en una tabla dada
function get_userid($conn,$email,$table) {
	$comm=sprintf("SELECT * FROM %s WHERE email='%s';\n",$table,$email);
        $res=sqlquery($conn,$comm,"Error en acceso a datos de usuario"); 
	if (db_numrows($res)==0) // no hay datos...
	   show_error("No encuentro usuario con el email dado en la tabla");
	$data=db_fetch_object ($res,0);
	return $data->userid;
}

//busca un usuario en una tabla
function lookup_user($conn,$userid,$table) {
	$comm=sprintf("SELECT * FROM %s WHERE userid=%s;\n",$table,$userid);
        $res=sqlquery($conn,$comm,"Error en acceso a datos de usuario"); 
	if (db_numrows($res)==0) // no hay datos...
	   show_error("No hay usuarios con el user_id pedido en la tabla");
	$data=db_fetch_object($res,0);
	return $data;
}

// obtiene datos de un usuario, dado su email
function lookup_user_by_email($conn,$email,$table) {
	$userid=get_userid($conn,$email,$table);
	return lookup_user($conn,$userid,$table);
}

// busca los datos de una lista de votantes dada
function lookup_list($conn,$id_lista) {
	$comm=sprintf("SELECT * FROM listas WHERE id_lista=%s;\n",$id_lista);
        $res=sqlquery($conn,$comm,"Error en acceso a datos de lista"); 
	if (db_numrows($res)==0)  // no hay datos...
	    show_error("La lista no existe en la base de datos");
	$data=db_fetch_object($res,0);
	return $data;
}

// busca los datos de una lista dado el email
function lookup_list_by_email($conn,$email) {
	$comm=sprintf("SELECT * FROM listas WHERE email='%s';\n",$email);
        $res=sqlquery($conn,$comm,"Error en acceso a datos de lista"); 
	if (db_numrows($res)==0)  // no hay datos...
	    show_error("La lista no existe en la base de datos");
	$data=db_fetch_object($res,0);
	return $data;
}

// busca una votacion en una tabla dada
function lookup_vote($conn,$voteid,$table) {
	$comm=sprintf("SELECT * FROM %s WHERE voteid=%s;\n",$table,$voteid);
        $res=sqlquery($conn,$comm,"Error en acceso a datos de votacion"); 
	if (db_numrows($res)==0)  // no hay datos...
	    show_error("La votacion solicitada no existe en la tabla $table");
	$data=db_fetch_object($res,0);
	$admin=lookup_user($conn,$data->userid,"usuarios");
	$lista=lookup_list($conn,$data->id_lista);
	$data->organizador=sprintf("%s %s <%s>",$admin->nombre,$admin->apellidos,$admin->email);
	$data->censo=sprintf("%s",$lista->nombre);
	return $data;
}

//-------------------- AUTENTIFICACION DE USUARIOS ----------------

// formulario de identificacin de usuarios
// pide nombre, userid y contrasea
// el resto de los tags deben ser aadidos externamente
// si flag, pide adems contrasea de voto

function query_user($flag,$email,$userid,$passwd,$votekey) {
	if ($GLOBALS["USE_HTTPS"]==1) {
		$ssl_email = getenv("SSL_CLIENT_S_DN_Email");
		if ( $ssl_email != "" ) {
		    if ( $email == "" ) $email=$ssl_email;
		    elseif ( $email != $ssl_email ) {
			printf("<h3>El certificado digital recibido no se
corresponde con los datos identificativos que el usuario ha introducido. <br>
Por favor revise los datos. En caso de duda, consulte con el administrador </h3>\n");
			show_error("SSL Certificate doesn't match which provided user email");
		    }
		}
	}
	printf( "<tr><th align=\"left\">E-mail:</th> <td><input type=text name=\"evote_email\" size=40 maxlength=40 value=\"%s\"></td> </tr>\n",$email);
	printf(" <tr> <th align=\"left\">Cdigo de usuario:</th> <td><input type=text name=\"evote_userid\" size=20 maxlength=20 value=\"%s\"></td> </tr>\n",$userid);
	printf(" <tr> <th align=\"left\">Contrasea:</th> <td><input type=password name=\"evote_passwd\" size=20 maxlength=20 value=\"%s\"></td> </tr>\n",$passwd);
if ($flag==1) {
	printf("<tr> <th align=\"left\">Clave de Votacin:</th> <td><input type=password name=\"evote_votekey\" size=20 maxlength=20 value=\"%s\"></td> </tr>\n",$votekey);
	}
}

// mira si un usuario est registrado y sus datos son correctos
// retorna userid
function certify_user ($con, $email, $userid, $passwd, $errormsg) {
	if ( $email=="" || $userid=="" || passwd=="" ) {
        	printf("%s\n",$errormsg);
		cierra_html();
        	db_Close($con);
        	exit;
	}
	$com=sprintf("SELECT * FROM usuarios WHERE ( email='%s' ) AND ( userid='%s' );\n",$email,$userid);
	$res=sqlquery($con,$com,$errormsg);
	$num=db_numrows($res);
	if ( $num==0 ) {
		// apunta en el syslog
		$msg=sprintf("Uid: %d\tVoteid: None\tAuth Error\n",$userid); 
		register_event("EVENT_AUTH",LOG_NOTICE,$msg);
		show_error($errormsg);
	}
	$userdata=db_fetch_object($res,0);
	if ( crypt($passwd,$userdata->passwd) != $userdata->passwd )
		show_error("Contrasea incorrecta");
	return $userdata->userid;
}

// comprueba nivel de acceso. retorna nivel de privilegio
function grant_access ( $con, $userid, $level, $errormsg) {
	$com=sprintf("SELECT * FROM usuarios WHERE (userid='%s') AND (groupid>='%s');\n",$userid,$level);
	$res=sqlquery($con,$com,"Error en verificacin de privilegios");
	$num=db_numrows($res);
	if ( $num==0 ) {
		// apunta en el syslog
		$msg=sprintf("Uid: %d\tVoteid: None\tPrivilege Violation\n",$userid); 
		register_event("EVENT_ACCESS",LOG_NOTICE,$msg);
		show_error($errormsg); // no tiene suficiente nivel
	}
	$user=db_fetch_object($res,0);
	return $user->groupid;
}

// comprueba que un usuario esta censado en una consulta restringida
function esta_censado ( $con, $userid, $listaid, $errormsg ) {
	$com=sprintf("SELECT * FROM user_acl WHERE (id_usuario='%s') AND (id_lista='%s');\n",$userid, $listaid);
	$res=sqlquery($con,$com,$errormsg);
	$num=db_numrows($res);
	if ( $num==0 ) {
		// apunta en el syslog
		$msg=sprintf("Uid: %d\tVoteid: None\tNot in List\n",$userid); 
		register_event("EVENT_ACCESS",LOG_INFO,$msg);
		show_error($errormsg);
	}
	return $num;
}

// ---------------------- ESTADISTICAS Y CONTEOS ------------------------

// retorna numero de usuarios inscritos en una votacion
function cuenta_censados ( $conn, $id_lista ) {
	$comm=sprintf("SELECT count(*) AS result FROM user_acl WHERE (id_lista=%d) AND (id_usuario>0) ;",$id_lista);
	$res=sqlquery ( $conn, $comm, "Error en calculo de votantes censados" );
	$obj=db_fetch_object( $res,0 );
	return $obj->result;
}

// retorna numero de usuarios que han solicitado tarjeta de voto
function cuenta_registrados ( $conn, $id_consulta ) {
	$comm=sprintf("SELECT count(*) AS result FROM votantes where id_consulta=%d;",$id_consulta );
	$res=sqlquery ( $conn, $comm, "Error en calculo de votantes registrados" );
	$obj=db_fetch_object( $res,0 );
	return $obj->result;
}

// retorna numero de votos emitidos en una consulta dada
function cuenta_votos ( $conn, $id_consulta ) {
	$comm=sprintf("SELECT count(*) AS result FROM votantes WHERE id_consulta=%d AND ha_votado='t';", $id_consulta );
	$res=sqlquery ( $conn, $comm,"Error en conteo de votos emitidos" );
	$obj=db_fetch_object( $res,0 );
	return $obj->result;
}

// lista los usuarios de una tabla en forma de tabla / formulario 
// si flag==1 los presenta como input type=radio
// los tags de <form> ,  submit, etc,  deben ser aadidos exteriormente
// el usuario 0 ( nobody ) y el usuario 1 ( admin ) no aparecen en el listado
function list_users($con, $table,$flag) {
	$com=sprintf("SELECT userid, apellidos, nombre, email FROM %s WHERE userid > 1 ORDER BY apellidos, nombre;",$table);
	$res=sqlquery($con,$com,"Error en consulta de tabla");
	if ( ($count=db_numrows($res)) == 0 ) {
		echo "No hay usuarios registrados en la tabla $table";
		cierra_html();
		exit;
	}
	printf("<table><tr><th>UserID</th><th>Apellidos, nombre</th><th>E-Mail</th></tr>\n");
	for ( $num=0; $num<$count; $num++ ) {
		if ($num==0) { $sel="checked";}  else { $sel=""; }
		$data=db_fetch_object($res,$num);
		$input_text="";
		if ( $flag == 1 ) $input_text=sprintf("<input type=radio name=\"userid\" value=\"%s\" %s>",$data->userid,$sel);
		printf("<tr><th>%s &nbsp; %s</th><td>%s, %s</td><td>%s</td></tr>\n",$input_text,$data->userid,$data->apellidos,$data->nombre,$data->email);
	}
	printf("</table>\n");
	return 0;
}

// muestra las listas de usuarios definidas
// flag=1 --> aade input type radio a cada entrada
function list_listas($con,$flag) {
	$com=sprintf("SELECT * FROM listas ORDER BY id_lista;");
	$res=sqlquery($con,$com,"Error en consulta de listas");
	if ( ($count=db_numrows($res)) == 0 ) {
		echo "No listas de usuarios registradas en el sistema";
		cierra_html();
		exit;
	}
	printf("<table><tr><th>ID Lista</th><th>Nombre, descripcin</th><th>E-Mail</th></tr>\n");
	for ( $num=0; $num<$count; $num++ ) {
		if ($num==0) { $sel="checked";}  else { $sel=""; }
		$data=db_fetch_object($res,$num);
		$input_text="";
		if ( $flag == 1 ) $input_text=sprintf("<input type=radio name=\"id_lista\" value=\"%s\" %s>",$data->id_lista,$sel);
		printf("<tr><th>%s &nbsp; %s</th><td>%s, %s</td><td>%s</td></tr>\n",$input_text,$data->id_lista,$data->nombre,$data->descripcion,$data->email);
	}
	printf("</table>\n");
	return 0;
}

// como el anterior, pero en forma de menu de seleccion
// sel indica el valor preseleccionado
function selecciona_lista($con,$default) {
	$com=sprintf("SELECT * FROM listas ORDER BY id_lista;");
	$res=sqlquery($con,$com,"Error en consulta de listas");
	if ( ($count=db_numrows($res)) == 0 ) {
		show_error( "No listas de usuarios registradas en el sistema");
		exit;
	}
	printf("<select name=\"id_lista\">\n");
	for ( $num=0; $num<$count; $num++ ) {
		$data=db_fetch_object($res,$num);
		if ($data->id_lista==$default) $sel="selected"; else $sel="";
		printf("<option value=%s %s> <b>%s</b>-  %s - <i>%s</i>\n",$data->id_lista,$sel,$data->id_lista,$data->nombre,$data->descripcion);
	}
	printf("</select>\n");
	return 0;
}

function list_lista_data($conn,$id_lista) {
	$data=lookup_list($conn,$id_lista);
	printf( "<table>\n");
	printf("<tr><th align=left>ID Lista:</th><td align=right>%s</td></tr>\n",$data->id_lista);
	printf("<tr><th align=left>Nombre:</th><td>%s</td></tr>\n",$data->nombre);
	printf("<tr><th align=left>Descripcin:</th><td>%s</td></tr>\n",$data->descripcion);
	printf("<tr><th align=left>E-Mail:</th><td>%s</td></tr>\n",$data->email);
	printf( "</table>\n");
}

// muestra los datos de un usuario en una tabla dada
function list_user_data($conn,$userid,$table) {
	$data=lookup_user($conn,$userid,$table);
	printf( "<table>\n");
	// solo listamos datos significativos.
	printf("<tr><th align=left>User ID:</th><td align=right>%s</td></tr>\n",$data->userid);
	if($table=="usuarios") printf("<tr><th align=left>Group ID:</th><td align=right>%s</td></tr>\n",$data->groupid);
	printf("<tr><th align=left>Apellidos, Nombre:</th><td>%s,%s</td></tr>\n",$data->apellidos,$data->nombre);
	printf("<tr><th align=left>Direccin:</th><td>%s</td></tr>\n",$data->direccion);
	printf("<tr><th align=left>Telfono:</th><td>%s</td></tr>\n",$data->telefono);
	printf("<tr><th align=left>E-Mail:</th><td>%s</td></tr>\n",$data->email);
	printf( "</table>\n");
}

// lista las votaciones existentes en una tabla dada
function list_vote( $con, $table, $flag) {
	$com=sprintf("SELECT voteid, titulo FROM %s ORDER BY voteid;",$table);
	$res=sqlquery($con,$com,"Error en consulta de votaciones");
	if ( ($count=db_numrows($res)) == 0 ) {
		echo "No hay consultas registradas en la tabla $table";
		cierra_html();
		exit;
	}
	printf("<table><tr><th>Ident</th><th>Ttulo de la consulta</th></tr>\n");
	for ( $num=0; $num<$count; $num++ ) {
		if ($num==0) { $sel="checked";} else { $sel=""; }
		$data=db_fetch_object($res,$num);
		$input_text="";
		if ( $flag == 1 ) $input_text=sprintf("<input type=radio name=\"voteid\" value=\"%s\" %s>",$data->voteid,$sel);
		printf("<tr><th>%s &nbsp; %s</th><td>%s</td></tr>\n",$input_text,$data->voteid,$data->titulo);
	}
	printf("</table>\n");
	return 0;
}

// lista los datos de una votacion

function list_vote_data($conn,$voteid,$table) {
	// datos de consulta
	$consulta=lookup_vote($conn,$voteid,$table);
	// datos del organizador
	$admindata=lookup_user($conn,$consulta->userid,"usuarios");
	// respuestas asociadas
	$rsptbl="respuestas";
	if ($table=="consultas_tmp") $rsptbl="respuestas_tmp";
	$comm=sprintf("SELECT * FROM %s WHERE id_consulta=%s;",$rsptbl,$voteid);
	$res2=sqlquery($conn,$comm,"Error en bsqueda de opciones de consulta");
	// lista de votantes
	$censo=lookup_list($conn,$consulta->id_lista);
	// a pintaaaarrrrr
	include("ficha_tecnica.php3");
}

// muestra las listas de interventores
// flag=1 --> aade input type radio a cada entrada
function list_interventores($con,$voteid,$flag) {
	$com=sprintf("SELECT DISTINCT apellidos, nombre, userid, email FROM usuarios,interventores WHERE ( usuarios.userid=interventores.id_usuario ) AND (id_consulta=%s) ORDER BY apellidos, nombre;",$voteid);
	$res=sqlquery($con,$com,"Error en consulta de interventores");
	if ( db_numrows($res) == 0 ) 
		printf("<p>No hay interventores registrados en esta consulta</p>");
	else {
		printf("<table><tr><th>Apellidos,Nombre</th><th>E-Mail</th></tr>\n");
		for ( $count=0; $count<db_numrows($res); $count++ ) {
			if ($count==0) { $sel="checked";}  else { $sel=""; }
			$data=db_fetch_object($res,$count);
			$input_text="";
			if ( $flag == 1 ) $input_text=sprintf("<input type=radio name=\"interv_id\" value=\"%s\" %s>",$data->userid,$sel);
			printf("<tr><td>%s &nbsp; %s,%s</td><td>&lt;%s&gt;</td></tr>\n",$input_text,$data->apellidos,$data->nombre,$data->email);
		}
		printf("</table>\n");
	}
	return db_numrows($res); // returns number of rows
}

// -----------------  CORREO ELECTRONICO -------------------------


// rutina para encriptar con PGP un mensaje ( algun dia...)
function pgp_crypt($msg,$user) {
	return $msg;
}

// rutina para firmar con PGP un mensaje ( algun dia...)
function pgp_sign($msg) {
	return $msg;
}

// rutina para encriptar con GnuPG un mensaje 
function gnupg_crypt($msg,$user) {
	return $msg;
}

// Rutina para firmar con GnuPG un mensaje
// BUG: debido al funcionamiento de GNUPG, 
// es necesario que el mensaje original este guardado en un fichero, en lugar
// de poder "empiparlo"... esto puede dar lugar a algun posible exploit de
// seguridad :(

function gnupg_sign($msg) {
	$tofile=tempnam( $GLOBALS["TMPDIR"], "gpg" );
	$com=sprintf("/usr/bin/gpg --command-fd 0 --passphrase-fd 0 --no-tty --homedir %s/gnupg --default-key %s -q -o %s --clearsign",$GLOBALS["LOGDIR"],$GLOBALS["ADMIN_EMAIL"],$tofile);
	$pipe=popen($com,"w");
	fwrite($pipe,getenv("PGP_PASSWD"));
	fwrite($pipe,"\n");
	fwrite($pipe,$msg);
	pclose($pipe);
	$fd=fopen( $tofile , "r" );
	$msg=fread($fd,filesize($tofile));
	fclose($fd);
	unlink($tofile);
	return $msg;
}

// manejo de template_files
function do_template( $filename, $templist ) {
        // pasa el fichero a un array
        $fichero=file($filename);
        // pasa cada linea del fichero por el filtro
        while ( list( $key, $val ) = each ( $fichero ) ) {
                reset($templist);
                while ( list( $from, $to ) = each ( $templist ) ) {
                        $val=ereg_replace($from,$to,$val);
                }
                $fichero[$key]=$val;
        }
        // convierte el fichero una vez procesado en un string y lo retorna
	// recuerda que el array ya incluye los "\n" en el fin de linea...
        $result=implode($fichero,"");
        return $result;
} 

// las siguientes funciones realizan cada una de las operaciones en que se
// necesita el uso del correo electronico. basicamente, las operaciones a
// realizar son: 
// - generar el array de templates
// - preprocesar el fichero asociado
// - enviar el correo

function fill_template ( $user,$vote,$votekey,$votetitle ) {

	// datos globales
	$templ["__ADMIN_EMAIL__"]=$GLOBALS["ADMIN_EMAIL"];
	$templ["__WEBPAGE__"]=$GLOBALS["WEBURL"];
	$templ["__DBTITLE__"]=$GLOBALS["DBTITLE"];
	// datos del usuario
	if ( is_object($user) ) {
		$templ["__EMAIL__"]=$user->email;
		$templ["__NOMBRE__"]=$user->nombre;
		$templ["__APELLIDOS__"]=$user->apellidos;
		$templ["__DIRECCION__"]=$user->direccion;
		$templ["__USERID__"]=$user->userid;
		$templ["__TELEFONO__"]=$user->telefono;
	}
	// datos del voto
	if ( is_object($vote) ) {
		$templ["__VOTE_ID__"]=$vote->voteid;
		$templ["__VOTE_TITLE__"]=$vote->titulo;
		$templ["__VOTE_ORGANIZER__"]=$vote->organizador;
		$templ["__VOTE_UNIVERSE__"]=$vote->censo;
		$templ["__VOTE_PREAMBLE__"]=$vote->preambulo;
		$templ["__VOTE_QUESTION__"]=$vote->pregunta;
	}
	// datos adicionales
	$templ["__VOTE_KEY__"]=$votekey;
	$templ["__DATE__"]=date("Y-m-d H:i");

	return $templ;
}

// enviar correo a una direccin ( no pgp check )
function send_mail_email($email,$subject,$text) {
	global $ADMIN_EMAIL;
	$extra=sprintf("From: %s\nX-Mailer: PHP/%s",$ADMIN_EMAIL,phpversion());
	return mail($email,$subject,$text,$extra);
}

// enviar correo a un usuario. Si tiene firma pgp se encripta el mensaje
function send_mail($user,$subject,$text) {
	global $ADMIN_EMAIL;
	$extra=sprintf("From: %s\nX-Mailer: PHP/%s",$ADMIN_EMAIL,phpversion());
	// enviamos evento al syslog
	$msg=sprintf("Uid: %d\tVoteid: None\tSending Mail\n",$user->userid); 
	register_event("EVENT_DEBUG",LOG_DEBUG,$msg);
	if ( $GLOBALS["USE_PGP"]=="NONE" ) // no tenemos soporte pgp
		return mail($user->email,$subject,$text,$extra);
	if ( $GLOBALS["USE_PGP"]=="PGP" ) { // usar soporte PGP
		$msg=pgp_sign($text);
		// si el usuario lo ha pedido, intentamos encriptar mensaje
		return mail($user->email,$subject,$msg,$extra);
	}
	if ( $GLOBALS["USE_PGP"]=="GnuPG" ) { // usar GNU PG
		$msg=gnupg_sign($text);
		// si el usuario lo ha pedido, intentamos encriptar mensaje
		return mail($user->email,$subject,$msg,$extra);
	}
	// error en soporte: manda mail plano y avisa al administrador
	mail($user->email,$subject,$text,$extra);
	mail($GLOBALS["ADMIN_EMAIL"],"Error en fichero de configuracion","Linea USE_PGP erronea","");
}

// Solicitud de tarjeta de voto
function ask_for_key($user,$vote,$votekey,$vote_title) {
	$template=fill_template($user,$vote,$votekey,$vote_title);
	$file=sprintf("%s/lib/freevote/lib/templates/ask_for_key",$GLOBALS["FREEVOTE_INST"]);
	$text=do_template($file,$template);
	send_mail($user,"Solicitud de tarjeta de voto",$text);
	return 0;
}

// Notificacion de aceptacion de nueva encuesta
function done_new_votation($user,$vote) {
	$template=fill_template($user,$vote,"",$vote->titulo);	
	$file=sprintf("%s/lib/freevote/lib/templates/done_new_votation",$GLOBALS["FREEVOTE_INST"]);
	$text=do_template($file,$template);
	send_mail($user,"Solicitud de consulta aceptada",$text);
	// manda al syslog
	$msg=sprintf("Uid: %d\tVoteid: %d\tRegister Consult\n",$user->userid,$vote->voteid); 
	register_event("EVENT_REGISTRY",LOG_NOTICE,$msg);
	return 0;
}

// Notificacion de inscripcion en el censo
function done_register_user($user) {
	$template=fill_template($user,"","","");	
	$file=sprintf("%s/lib/freevote/lib/templates/done_register_user",$GLOBALS["FREEVOTE_INST"]);
	$text=do_template($file,$template);
	send_mail($user,"Inscripcion en el censo realizada",$text);
	// manda al syslog
	$msg=sprintf("Uid: %d\tVoteid: None\tRegister User\n",$user->userid); 
	register_event("EVENT_REGISTRY",LOG_NOTICE,$msg);
	return 0;
}

// Notificacion de borrado del censo
function done_del_user($user) {
	$template=fill_template($user,"","","");	
	$file=sprintf("%s/lib/freevote/lib/templates/done_del_user",$GLOBALS["FREEVOTE_INST"]);
	$text=do_template($file,$template);
	send_mail($user,"Registro en el sistema de voto borrado",$text);
	// manda al syslog
	$msg=sprintf("Uid: %d\tVoteid: None\tUnregister User\n",$user->userid); 
	register_event("EVENT_REGISTRY",LOG_NOTICE,$msg);
	return 0;
}

// Notificacin de inscripcin como interventor
function register_interventor($user,$vote) {
        $template=fill_template($user,$vote,"",$vote->titulo);
	$file=sprintf("%s/lib/freevote/lib/templates/add_interventor",$GLOBALS["FREEVOTE_INST"]);
        $text=do_template($file,$template);
        send_mail($user,"Inscripcion como interventor",$text);
	// generamos evento de syslog
	$msg=sprintf("Uid: %d\tVoteid: %d\tRegister Interventor\n",$user->userid,$vote->voteid);
	register_event("EVENT_REGISTRY",LOG_NOTICE,$msg);
        return 0;
}

// Notificacin de borrado como interventor
function unregister_interventor($user,$vote) {
        $template=fill_template($user,$vote,"",$vote->titulo);
	$file=sprintf("%s/lib/freevote/lib/templates/delete_interventor",$GLOBALS["FREEVOTE_INST"]);
        $text=do_template($file,$template);
        send_mail($user,"Cancelacion de inscripcion como interventor",$text);
	// generamos evento de syslog
	$msg=sprintf("Uid: %d\tVoteid: %d\tUnregister Interventor\n",$user->userid,$vote->voteid);
	register_event("EVENT_REGISTRY",LOG_NOTICE,$msg);
        return 0;
}

// Notificacion de no aceptacion de usuario
function done_refuse_user($user,$motivo) {
        $template=fill_template($user,"","",$motivo);
	$file=sprintf("%s/lib/freevote/lib/templates/done_refuse_user",$GLOBALS["FREEVOTE_INST"]);
        $text=do_template($file,$template);
        send_mail($user,"Solicitud de registro de usuario rechazada",$text);
	// manda al syslog
	$msg=sprintf("Uid: %d\tVoteid: None\tRefuse User\n",$user->userid); 
	register_event("EVENT_REGISTRY",LOG_NOTICE,$msg);
        return 0;
}
                                                                                
// Notificacion de modificacion de datos
function done_edit_user($user,$email,$passwd) {
	$template=fill_template($user,"",$passwd,"");	
	$file=sprintf("%s/lib/freevote/lib/templates/done_edit_user",$GLOBALS["FREEVOTE_INST"]);
	$text=do_template($file,$template);
	if ($email=="")
	    send_mail($user,"Modificacion de datos personales",$text);
	else
	    send_mail_email($email,"Modificacion de datos personales",$text);
	// manda al syslog
	$msg=sprintf("Uid: %d\tVoteid: None\tChange User\n",$user->userid); 
	register_event("EVENT_REGISTRY",LOG_NOTICE,$msg);
	return 0;
}

// Notificacion de voto realizado
function emitted_vote($user,$vote) {
	$template=fill_template($user,$vote,"",$vote->titulo);	
	$file=sprintf("%s/lib/freevote/lib/templates/emitted_vote",$GLOBALS["FREEVOTE_INST"]);
	$text=do_template($file,$template);
	send_mail($user,"Notificacion de emision de voto",$text);
	return 0;
}

// Solicitud de inscripcion de usuario en el censo
function todo_register_user($user) {
	$template=fill_template($user,"","","");	
	$file=sprintf("%s/lib/freevote/lib/templates/todo_register_user",$GLOBALS["FREEVOTE_INST"]);
	$text=do_template($file,$template);
	send_mail($user,"Solicitud de registro recibida",$text);
	// manda al syslog
	$msg=sprintf("Uid: %d\tVoteid: None\tNew User\n",$user->userid); 
	register_event("EVENT_REGISTRY",LOG_INFO,$msg);
	return 0;
}

// Solicitud de inscripcion de nueva consulta
function todo_new_votation($user,$vote) {
	$template=fill_template($user,$vote,"",$vote->titulo);
	$file=sprintf("%s/lib/freevote/lib/templates/todo_new_votation",$GLOBALS["FREEVOTE_INST"]);
	$text=do_template($file,$template);
	send_mail($user,"Solicitud de inscripcion de nueva consulta",$text);
	// manda al syslog
	$msg=sprintf("Uid: %d\tVoteid: %d\tNew Consult\n",$user->userid,$vote->voteid); 
	register_event("EVENT_REGISTRY",LOG_INFO,$msg);
	return 0;
}

// Solicitud de borrado de consulta
function done_del_votation($user,$vote) {
	$template=fill_template($user,$vote,"",$vote->titulo);
	$file=sprintf("%s/lib/freevote/lib/templates/done_del_votation",$GLOBALS["FREEVOTE_INST"]);
	$text=do_template($file,$template);
	send_mail($user,"Eliminacion de consulta en el sistema",$text);
	// manda al syslog
	$msg=sprintf("Uid: %d\tVoteid: %d\tUnregister Consult\n",$user->userid,$vote->voteid); 
	register_event("EVENT_REGISTRY",LOG_NOTICE,$msg);
	return 0;
}

// Envio de datos censales a un interventor
function email_censo($user,$vote,$lista) {
	$template=fill_template($user,$vote,"",$vote->titulo);
	$file=sprintf("%s/lib/freevote/lib/templates/envia_censo",$GLOBALS["FREEVOTE_INST"]);
	$text=do_template($file,$template);
	$text=sprintf("%s\n%s\n",$text,$lista);
	send_mail($user,"Envio de datos censales",$text);
	// manda al syslog
	$msg=sprintf("Uid: %d\tVoteid: %d\tSend Votelist\n",$user->userid,$vote->voteid); 
	register_event("EVENT_ADMIN",LOG_DEBUG,$msg);
	return 0;
}

// ------------------------- ADMINISTRACION -----------------------------

// TODO: para una futura version, considerar el no usar tablas temporales,
// sino una marca de "Aceptado". Esto evitara posibles problemas de
// consistencia y duplicidad de identificadores as como la necesidad de
// operaciones de begin/rollback/commit. Afortunadamente postgresql no
// tiene ese problema, pero no se puede decir lo mismo de otras RDBMS


// acepta un usuario pendiente de registro y lo inscribe

function accept_user($conn,$userid,$groupid) {
	$comm=sprintf("BEGIN TRANSACTION;");
	$res=sqlquery($conn,$comm,"Error en aceptacin de usuario(0)");	
	$comm=sprintf("INSERT INTO usuarios ( userid, groupid,passwd, nombre, apellidos, direccion, telefono, email) SELECT userid, %s AS groupid, passwd, nombre, apellidos, direccion, telefono, email FROM usuarios_tmp WHERE userid=%s;",$groupid,$userid);
	$res=db_query($conn,$comm);
	if (!$res) {
		db_query($conn,"ROLLBACK TRANSACTION;");
		show_error("Error en aceptacin de usuario(1)");
	}
	$comm=sprintf("DELETE FROM usuarios_tmp WHERE userid=%s;",$userid);
	$res=db_query($conn,$comm);
	if (!$res) {
		db_query($conn,"ROLLBACK TRANSACTION;");
		show_error("Error en aceptacin de usuario(2)");
	}
	$res=db_query($conn,"COMMIT TRANSACTION;");
	// manda al syslog
	$msg=sprintf("Uid: %d\tVoteid: None\tAccept User\n",$userid); 
	register_event("EVENT_ADMIN",LOG_INFO,$msg);
}

// acepta una votacin pendiente de registro y la inscribe

function accept_vote($conn,$voteid) {
	$comm=sprintf("BEGIN TRANSACTION");
	$res=sqlquery($conn,$comm,"Error en aceptacin de consulta(0)");	
	$comm=sprintf("INSERT INTO consultas SELECT * FROM consultas_tmp WHERE voteid=%s;",$voteid);
	$res=db_query($conn,$comm);
	if (!$res) {
		db_query($conn,"ROLLBACK TRANSACTION;");
		show_error("Error en aceptacin de consulta(1)");
	}
	$comm=sprintf("INSERT INTO respuestas SELECT * FROM respuestas_tmp WHERE id_consulta=%s;",$voteid);
	$res=db_query($conn,$comm);
	if (!$res) {
		db_query($conn,"ROLLBACK TRANSACTION;");
		show_error("Error en aceptacin de consulta(2)");
	}
	$comm=sprintf("DELETE FROM consultas_tmp WHERE voteid=%s;",$voteid);
	$res=db_query($conn,$comm);
	if (!$res) {
		db_query($conn,"ROLLBACK TRANSACTION;");
		show_error("Error en aceptacin de consulta(3)");
	}
	$comm=sprintf("DELETE FROM respuestas_tmp WHERE id_consulta=%s;",$voteid);
	$res=db_query($conn,$comm);
	if (!$res) {
		db_query($conn,"ROLLBACK TRANSACTION;");
		show_error("Error en aceptacin de consulta(4)");
	}
	$res=db_query($conn,"COMMIT TRANSACTION;");
	// manda al syslog
	$msg=sprintf("Uid: None\tVoteid: %d\tAccept Vote\n",$voteid); 
	register_event("EVENT_ADMIN",LOG_INFO,$msg);
}

// actualiza datos de un usuario
function change_user($conn,$userid,$data) {
	// el userid es lo unico que no puede cambiar
	// recuerda que el email es UNIQUE INDEX ....
	$comm=sprintf("UPDATE usuarios SET groupid=%s, nombre='%s', apellidos='%s', direccion='%s', telefono='%s', email='%s', passwd='%s' WHERE userid=%s ;",$data[groupid],$data[nombre],$data[apellidos],$data[direccion],$data[telefono],$data[email],$data[passwd],$userid);
	$res=sqlquery($conn,$comm,"Error en actualizacin de datos de usuario");
}


// actualiza datos de un usuario incluyendo contrasea y correo
// no cambian: nombre, apellidos, userid, y groupid
function change_user_and_passwd($conn,$userid,$data) {
	$comm=sprintf("UPDATE usuarios SET email='%s', direccion='%s', telefono='%s', passwd='%s' WHERE userid=%s ;",$data[email],$data[direccion],$data[telefono],crypt($data[passwd1]),$userid);
	$res=sqlquery($conn,$comm,"Error en actualizacin de datos de usuario");
}

// actualiza datos de una votacion 
function change_vote( $conn,$voteid,$vote_data ) {
	// NO SOPORTADO ( y no s si se debe soportar.... )
	printf ("Function not supported yet\n");
}

// actualiza la lista de usuarios que pertenecen a un grupo dado
function update_userlist($conn,$id_lista,$usuario) {
	$comm=sprintf("BEGIN TRANSACTION;");
	$res=sqlquery($conn,$comm,"Error en update_userlist(0)");
	// eliminamos entradas actuales de la lista
	$comm=sprintf("DELETE FROM user_acl WHERE id_lista=%s;",$id_lista);
	$res=db_query($conn,$comm);
        if (!$res) {
                db_query($conn,"ROLLBACK TRANSACTION;");
                show_error("Error en update_userlist(1)");
        } 
	// insertamos nuevas entradas	
	while (list($userid,$value)=each($usuario) ) {
		$comm=sprintf("INSERT INTO user_acl(id_usuario,id_lista) VALUES (%s,%s);",$userid,$id_lista);
		$res=db_query($conn,$comm);
        	if (!$res) {
                	db_query($conn,"ROLLBACK TRANSACTION;");
                	show_error("Error en update_userlist(2)");
		}
	}
	$res=db_query($conn,"COMMIT TRANSACTION;"); 
	return 0;
}

// borra datos de un usuario 
function remove_user( $conn,$userid,$table) {
	// TODO: por defecto, la eliminacin de un usuario lleva en cascada
	// la eliminacin de todas las votaciones que haya organizado...
	// en una segunda versin, dichas votaciones deben ser asignadas
	// al administrador. En nuestro caso necesitariamos que la
	// RDBMS soportara el MATCH PARTIAL y que el administrador tuviera
	// siempre como userid el valor de DEFAULT, o bien simularlo a mano...

	// truco: hacemos que siempre exista el usuario "nobody" con userid=0
	// y ponemos "on delete set to nobody"

	// recuerda que solo postgres soporta integridad referencial,
	// y las opciones de ON DELETE CASCADE....

	$comm=sprintf("DELETE FROM %s WHERE userid=%s;",$table,$userid);
	$res=sqlquery($conn,$comm,"Error en eliminacin de usuario");
}

// borra datos de una votacion
function remove_vote ($conn,$voteid,$table) {
	// el ON DELETE CASCADE, borra por simpata las respuestas asociadas
	// en la tabla respuestas_tmp ...

	$comm=sprintf("DELETE FROM %s WHERE voteid=%s;",$table,$voteid);
	$res=sqlquery($conn,$comm,"Error en eliminacin de consulta");
}

// consola sql

function sql_console ($conn,$query) {
	global $DBNAME,$DBPORT,$DBHOST;
	if ( $query=="" ) return "&lt;empty&gt;"; 
	$command=sprintf("psql %s -U %s -p %s -h %s -c '%s'\n",
		$DBNAME,getenv("DBUSER"),$DBPORT,$DBHOST,$query);
	// warnning: what about escape shell and so comands?
	passthru($command);
}

// -------------------- EMISION DE VOTO -------------------------

// recuerda que la clave de voto no esta encriptada. Esto se hace as porque
// puede ser necesario reenviarsela al usuario una vez generada, y no
// existe la funcion decrypt()....

// mira si un usuario ha votado ya o no
function ha_votado($conn,$userid,$voteid) {
	// si retorna cero puede ser debido a que no est inscrito o que no
	// haya votado. es responsabilidad del usuario discernir cada caso
	$comm=sprintf("SELECT * FROM votantes WHERE (id_consulta=%s) AND (id_usuario=%s) AND (ha_votado='t') ;",$voteid,$userid);
	$res=sqlquery($conn,$comm,"Error en chequeo de voto realizado");
	$num=db_numrows($res);
	if ( $num==0 ) return 0; 
	return 1;
}

// mira si un usuario puede votar en una votacin
function puede_votar($conn,$userid,$voteid) {
	// inscrito y en periodo de votacion ?
	$com=sprintf(" 
	SELECT user_acl.id_usuario AS userid 
	FROM consultas, user_acl 
	WHERE 	( user_acl.id_usuario=%s )
	AND ( user_acl.id_lista=consultas.id_lista )
	AND ( consultas.voteid=%s )
	AND ( consultas.start_votacion <= '%s' )
	AND ( consultas.end_votacion >= '%s' ) ;"
	,$userid,$voteid,date("Y-m-d"),date("Y-m-d"));
	// printf("%s\n",$com);
	$res=sqlquery($conn,$com,"Error en puede_votar(censo+fecha)");
	if (db_numrows($res)==0) return 0; // no esta inscrito o no periodo
	// ha votado ya ?
	// if ( ha_votado($conn,$userid,$voteid) ) return 0;
	return 1;
}

// comprueba la tarjeta de voto de un votante. si esta no existe, o la clave
// es incorrecta, retorna cero
function verify_votecard($conn,$userid,$voteid,$key) {
	$comm=sprintf("SELECT * FROM votantes WHERE (id_consulta=%s) AND (id_usuario=%s) AND (vote_key='%s');",$voteid,$userid,$key);
	$res=sqlquery($conn,$comm,"Error al validar la tarjeta de voto");
	$num=db_numrows($res);
	if ( $num==0 ) return 0; 
	return 1;
}

// mira si un usuario puede inscribirse en una votacion
function puede_inscribirse($conn,$userid,$voteid) {
	// inscrito y en periodo de votacion ?
	$com=sprintf(" 
	SELECT user_acl.id_usuario AS userid 
	FROM consultas, user_acl 
	WHERE 	(user_acl.id_usuario=%s )
	AND ( user_acl.id_lista=consultas.id_lista )
	AND ( consultas.voteid=%s )
	AND ( consultas.start_inscripcion <= '%s' )
	AND ( consultas.end_inscripcion >= '%s' ) ;"
	,$userid,$voteid,date("Y-m-d"),date("Y-m-d"));
	$res=sqlquery($conn,$com,"Error en puede_inscribirse(censo+fecha)");
	if (db_numrows($res)==0) return 0; // no esta inscrito o no periodo
	// ha votado ya ?
	if ( ha_votado($conn,$userid,$voteid) ) return 0;
	return 1;
}

// mira si un usuario ha solicitado tarjeta de voto
function esta_inscrito($conn,$userid,$voteid) {
	// si retorna cero puede ser debido a que no est inscrito o que no
	// haya votado. es responsabilidad del usuario discernir cada caso
	$comm=sprintf("SELECT * FROM votantes WHERE (id_consulta=%s) AND (id_usuario=%s) ;",$voteid,$userid);
	$res=sqlquery($conn,$comm,"Error en chequeo de inscripcin");
	$num=db_numrows($res);
	if ( $num==0 ) return 0; 
	return 1;
}

// emisin de tarjeta de voto
// retorna clave de voto
function do_inscripcion($conn,$user,$vote) {
	// si el usuario ya est inscrito o ya ha votado, el insert dar
	// error de integridad referencial
	// la generacion de la clave de voto es simple: 
	// la obtenemos encriptando la fecha actual en formato 
	// sshhmmDDMMAAAA con una semilla aleatoria
	// se admiten sugerencias para buscar algo mas aleatorio...
	$key=crypt(date("sihdmY"));
	$comm=sprintf("INSERT INTO votantes VALUES (%s,%s,'%s','false');",$vote->voteid,$user->userid,$key);
	$res=db_query($conn,$comm);
	if (!$res) printf("<p>El votante ya ha registrado previamente su solicitud de voto\n</p>");
	// se le manda mail con los datos
	$comm=sprintf("SELECT * FROM votantes WHERE (id_consulta=%s) AND (id_usuario=%s);",$vote->voteid,$user->userid);
	$res=sqlquery($conn,$comm,"Error obteniendo datos de tarjeta de voto");
	$data=db_fetch_object($res,0);
	return $data->vote_key;
}

// acto fisico diodenal de votar por la gloria de mi madrreee
function do_vote($conn,$user,$vote,$vote_opt) {

	// se presupone que el usuario ya est autentificado ...
	$res=sqlquery($conn,"BEGIN TRANSACTION;","Error en proceso de voto(0)");
	$contenido="";
	// en caso de voto no secreto, guarda contenido del voto
	if ( $vote->is_secret == "f" )	$contenido=sprintf(", vote_data='%s' ",$vote_opt);
	$comm=sprintf("UPDATE votantes SET ha_votado='true' %s WHERE (id_consulta=%s) AND (id_usuario=%s) AND (ha_votado='f');", $contenido, $vote->voteid, $user->userid);
	$res=db_query($conn,$comm);
	// si no actualiza ninguna fila es que o no registrado o ya ha votado
	if ( !$res ) {
		db_query($conn,"ROLLBACK TRANSACTION;");
		show_error("Error en proceso de voto(1)");
	}
	$comm=sprintf("UPDATE respuestas SET result=(result+1) WHERE (short_answer='%s') AND (id_consulta=%s);",$vote_opt,$vote->voteid);
	$res=db_query($conn,$comm);
	if (!$res) {
		db_query($conn,"ROLLBACK TRANSACTION;");
		show_error("Error en proceso de voto(2)");
	}
	$res=db_query($conn,"COMMIT TRANSACTION;");
}

// ------------------ Gestion de foros de debate ------------------------

// pinta una coleccion de comentarios en forma de arbol de dependencias
// la funcion se llama recursivamente para recorrer el arbol

// TODO: estudiar la optimizacion del codigo. Pista: el array esta ordenado
// segun $irt ( in_response_to )
function print_comments($conn,$com,$irt) {
	$flag=0;
	for($i=0; $i<sizeof($com);$i++) {
	    if ( $com[$i]->in_response_to != $irt ) continue;
	    if ( $com[$i]->userid == 0 ) continue; // skip nobody's default msg
	    if ($flag==0) printf("<ul>\n"); 
	    $flag=1;
	    // pinta item
	    $user=lookup_user($conn,$com[$i]->userid,"usuarios");
	    printf("<li><input type=radio name=\"commentid\" value=%s> <u>%s</u> <b>%s</b> Enviado por <i>%s</i> con fecha %s ",
	    	$com[$i]->commentid,$com[$i]->commentid,$com[$i]->subject,$user->email,$com[$i]->fecha);
	    printf("<p>%s</p>\n",nl2br(htmlspecialchars($com[$i]->comment)) );
	    // busca mensajes dependientes de este ( llamada recursiva )
	    print_comments($conn,$com,$com[$i]->commentid,$id);
	}
	if ($flag==1) printf("</ul>\n");
}

// ------- funciones asociadas a la gestion de interventores -------------

// NOTA:
// los eventos de cambio/envio del censo son generados inmediatamente.
// Para los eventos de tarjeta y voto, se consulta el modo y solo se
// envan aquellos que tienen modo cero ( inmediato ). los eventos de
// modo diferido, se gestionan desde el cron y el syslog

// consulta en la db la lista de interventores asociados a una votacion
// truco: 
// flag es un string que anyade condiciones particulares a la busqueda
// esto permite hacer busquedas selectivas en funcion de las opciones que
// el interventor ha seleccionado
// ejemplo: $flag="AND ( interventores.envia_tarjetas=true )"

function busca_interventores($conn,$vote,$flag) {
	$com=sprintf("SELECT DISTINCT apellidos, nombre, userid, email FROM usuarios,interventores WHERE ( usuarios.userid=interventores.id_usuario ) AND (interventores.id_consulta=%s) %s ORDER BY apellidos, nombre;",$vote->voteid,$flag);
// printf("<p>%s</p>\n",$com);
        $res=sqlquery($conn,$com,"Error en consulta de interventores");
	return $res;
}

// envia lista de censados a un interventor
// utilizada al dar de alta un interventor 
function envia_censo($conn,$user,$vote) {
	// consultamos censo
	$comm=sprintf(" SELECT DISTINCT apellidos,nombre FROM usuarios,consultas,user_acl WHERE (consultas.voteid=%s) AND (usuarios.userid=user_acl.id_usuario) AND (consultas.id_lista=user_acl.id_lista) AND (user_acl.id_usuario>0) ORDER BY apellidos, nombre ;",$vote->voteid);
	$res=sqlquery($conn,$comm,"Error en consulta de censo");
	// elaboramos lista del censo
	$lista="";
	for ($count=0; $count<db_numrows($res); $count ++ ) {
		$item=db_fetch_object($res,$count);
		$lista=sprintf("%s%d:\t%s , %s\n",$lista,$count+1,$item->apellidos,$item->nombre);
	}
	// enviamos emilio al interventor
	email_censo($user,$vote,$lista);
	return 0;
}

// envia lista de censados a todos los interventores que solicitan evento
// de notificacion de actualizacion de censo
function notifica_nuevo_censo($conn,$vote) {
	$flag="AND (interventores.envia_cambios=true)";
	$res=busca_interventores($conn,$vote,$flag);
	for ( $count=0; $count<db_numrows($res); $count++ ) {
		$item=db_fetch_object($res,$count);
		$user=lookup_user($conn,$item->userid,"usuarios");
		envia_censo($conn,$user,$vote);
	}
	return $count; // retorna numero de notificaciones
}

// envia a un interventor evento de solicitud de tarjeta de voto
function envia_tarjeta($conn,$interv,$user,$vote) {
	return 0;
}

// envia evento de solicitud de tarjeta de voto a todos los interventores
// que han solicitado dicho evento en modo de envio inmediato
function notifica_tarjeta($conn,$user,$vote) {
	$flag="AND (interventores.envia_tarjetas=true) AND (interventores.send_modo=0)";
	$res=busca_interventores($conn,$vote,$flag);
	for ( $count=0; $count<db_numrows($res); $count++ ) {
		$item=db_fetch_object($res,$count);
		$interv=lookup_user($conn,$item->userid,"usuarios");
		envia_tarjeta($conn,$interv,$user,$vote);
	}
	return $count; // retorna numero de notificaciones
}

// envia a un interventor evento de emision de voto
// si voto no secreto, indica contenido
function envia_voto($conn,$interv,$user,$vote,$vote_sel) {
	return 0;
}

// envia evento de emision de voto a los interventores 
// que han solicitado dicho evento en modo de envio inmediato
function notifica_voto($conn,$user,$vote,$vote_sel) {
	$flag="AND (interventores.envia_voto=true) AND (interventores.send_modo=0)";
	$res=busca_interventores($conn,$vote,$flag);
	for ( $count=0; $count<db_numrows($res); $count++ ) {
		$item=db_fetch_object($res,$count);
		$interv=lookup_user($conn,$item->userid,"usuarios");
		envia_voto($conn,$interv,$user,$vote,$vote_sel);
	}
	return $count; // retorna numero de notificaciones
}

?>

