-- **********************************************************************
-- ** Fichero de ejemplo para realizar pruebas con el sistema Free-Vote
-- **********************************************************************

-- IMPORTANTE: este ejemplo debe ejecutarse con una database limpia. se hacen
-- diversas suposiciones sobre el contenido de los contadores y secuencias
-- de las tablas de la base de datos, que solo son ciertas en el momento 
-- inicial ( tras la ejecucion de ./install.sh -restart-db ).

-- Lista de usuarios registrados
-- las contraseas son de la forma "nombreX" X->[0..9]
INSERT INTO usuarios(groupid,passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	2,'nosT.fu8ORX6c','Apellido0','Nombre0','Mi calle 0','mi telefono 0','nombre0@lista1.com'
);
INSERT INTO usuarios(groupid,passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	3,'noDbWkzj9Na6k','Apellido1','Nombre1','Mi calle 1','mi telefono 1','nombre1@lista1.com'
);
INSERT INTO usuarios(groupid,passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	4,'nowwZ/qqLPB/k','Apellido2','Nombre2','Mi calle 2','mi telefono 2','nombre2@lista1.com'
);
INSERT INTO usuarios(groupid,passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	5,'noQOM5ztYzDoY','Apellido3','Nombre3','Mi calle 3','mi telefono 3','nombre3@lista1.com'
);
INSERT INTO usuarios(passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	'no.UE7/3KzvNs','Apellido4','Nombre4','Mi calle 4','mi telefono 4','nombre4@lista2.com'
);
INSERT INTO usuarios(passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	'noHNFBWpn3oAM','Apellido5','Nombre5','Mi calle 5','mi telefono 5','nombre5@lista2.com'
);
INSERT INTO usuarios(passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	'nouhx3KQyGYWg','Apellido6','Nombre6','Mi calle 6','mi telefono 6','nombre6@lista2.com'
);
INSERT INTO usuarios(passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	'no9sCjJs11FkY','Apellido7','Nombre7','Mi calle 7','mi telefono 7','nombre7@lista2.com'
);
INSERT INTO usuarios(passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	'noPhxJuiFjeo6','Apellido8','Nombre8','Mi calle 8','mi telefono 8','nombre8@lista2.com'
);
INSERT INTO usuarios(passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	'no5ThnIdVNctI','Apellido9','Nombre9','Mi calle 9','mi telefono 9','nombre9@lista2.com'
);

-- Usuarios pendientes de registro

INSERT INTO usuarios_tmp(passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	'no8bg/Vn.qzko','Apellido10','Nombre10','Mi calle 10','mi telefono 10','nombre10@lista3.com'
);
INSERT INTO usuarios_tmp(passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	'noAl0KBz0I5FQ','Apellido11','Nombre11','Mi calle 11','mi telefono 11','nombre11@lista3.com'
);
INSERT INTO usuarios_tmp(passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	'noJSblp8WdF5Q','Apellido12','Nombre12','Mi calle 12','mi telefono 12','nombre12@lista3.com'
);
INSERT INTO usuarios_tmp(passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	'noWLt0486VtxA','Apellido13','Nombre13','Mi calle 13','mi telefono 13','nombre13@lista3.com'
);
INSERT INTO usuarios_tmp(passwd,apellidos,nombre,direccion,telefono,email) VALUES (
	'noF7BwXDZBE.U','Apellido14','Nombre14','Mi calle 14','mi telefono 14','nombre14@lista3.com'
);

-- listas de votantes
INSERT INTO listas(nombre,descripcion,email) VALUES (
	'Hispalinux','Miembros de la Asociacin Hispalinux','lista1@lista1.com'
);
INSERT INTO listas(nombre,descripcion,email) VALUES (
	'Lista 2','Miembros de la Lista 2','lista2@lista2.com'
);
INSERT INTO listas(nombre,descripcion,email) VALUES (
	'Lista 3','Miembros de la Lista 3','lista3@lista3.com'
);

-- Asignacin de votantes a usuarios
INSERT INTO user_acl(id_lista,id_usuario) SELECT id_lista,userid FROM listas,usuarios WHERE usuarios.email LIKE '%lista1.com' AND listas.email LIKE '%lista1.com';
INSERT INTO user_acl(id_lista,id_usuario) SELECT id_lista,userid FROM listas,usuarios WHERE usuarios.email LIKE '%lista2.com' AND listas.email LIKE '%lista2.com';

-- Votaciones
INSERT INTO consultas(titulo,userid,preambulo,pregunta,start_convocatoria,end_convocatoria,start_inscripcion,end_inscripcion,start_votacion,end_votacion,id_lista,is_restricted,is_secret,has_forum,allow_percent,allow_results,allow_list) VALUES ('Qu te parece este sistema de voto',0,'Este programa est an en fase experimental. Necesitamos conocer tu opinin','Qu opinas de este sistema de voto?','2000-07-01','2000-12-31','2000-08-01','2000-12-31','2000-08-01','2000-12-30',0,false,true,true,true,true,false);

INSERT INTO respuestas VALUES (1,'DABUTEN','Inmejorable, ideal, me lo estoy bajando',0);
INSERT INTO respuestas VALUES (1,'BUENO','Bastante bueno, me gusta, casi se puede usar tal cual',0);
INSERT INTO respuestas VALUES (1,'REGULAR','La idea es buena, pero yo cambiara algunas cosas',0);
INSERT INTO respuestas VALUES (1,'MALO','La verdad, es manifiestamente mejorable',0);
INSERT INTO respuestas VALUES (1,'PESIMO','Dedcate a las chapas, porque a programar...',0);
 
INSERT INTO consultas(titulo,userid,preambulo,pregunta,start_convocatoria,end_convocatoria,start_inscripcion,end_inscripcion,start_votacion,end_votacion,id_lista,is_restricted,is_secret,has_forum,allow_percent,allow_results,allow_list) VALUES ('Fechas para la celebracin del Congreso Hispalinux',0,'En los diversos foros de Linux se ha suscitado la duda sobre la conveniencia de determinadas fechas para la celebracin del congreso. Esta es tu oportunidad para votar','En qu fechas consideras que debe celebrarse el III Congreso Hispalinux?','2000-07-01','2000-12-31','2000-08-01','2000-10-31','2000-08-01','2000-10-31',1,true,false,true,true,false,false);

INSERT INTO respuestas VALUES (2,'3-5 Nov','Antes del SIMO',0);
INSERT INTO respuestas VALUES (2,'10-12 Nov','En la semana del SIMO',0);
INSERT INTO respuestas VALUES (2,'Ninguna','Ninguna de estas',0);

-- Votaciones pendientes de aprobacion

INSERT INTO consultas_tmp(titulo,userid,preambulo,pregunta,start_convocatoria,end_convocatoria,start_inscripcion,end_inscripcion,start_votacion,end_votacion,id_lista,is_restricted,allow_percent,allow_results) VALUES ('Los caballeros las prefieren...',0,'Encuesta medio broma medio en serio para saber las apetencias de los varones espaoles sobre el color de sus amables amigas del sexo opuesto','Y a t cmo te gustan ms?','2000-07-01','2000-12-31','2000-08-01','2000-10-31','2000-08-01','2000-10-31',2,false,true);

INSERT INTO respuestas_tmp VALUES (3,'Rubias','En plan Marylin, explosivas',0);
INSERT INTO respuestas_tmp VALUES (3,'Morenas','Rita Hayworth es mi dolo',0);
INSERT INTO respuestas_tmp VALUES (3,'Pelirrojas','Nada, Julia Roberts al poder',0);
INSERT INTO respuestas_tmp VALUES (3,'Indiferente','Mientras estn buenas...',0);

-- comentarios para el foro de debates

INSERT INTO foro (userid,voteid,in_response_to,subject,comment) VALUES (2,1,0,'Comentario 1','Esto es un comentario a la votacion 1');
INSERT INTO foro (userid,voteid,in_response_to,subject,comment) VALUES (3,1,0,'Comentario 2','Esto es otro comentario a la votacion 1');
INSERT INTO foro (userid,voteid,in_response_to,subject,comment) VALUES (4,1,3,'Comentario 3','Esto es un comentario al comentario 1');
INSERT INTO foro (userid,voteid,in_response_to,subject,comment) VALUES (5,1,5,'Comentario 4','Esto es un comentario al comentario 3');
INSERT INTO foro (userid,voteid,in_response_to,subject,comment) VALUES (6,1,3,'Comentario 5','Esto es otro comentario al comentario 1');

